/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.51 Revision 1.114
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.51 2009/11/10 00:56:29 spatz Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.114 2012/01/01 18:12:03 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
14MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
17IUSE="${IUSE} debug pch" 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
18RDEPEND=" 32RDEPEND="
19 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
21 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
23 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
24 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
25 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
26 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
27 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV} 49 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999 50 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV} 51 !<x11-libs/qt-qt3support-${PV}
43 !<x11-libs/qt-webkit-${PV} 61 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999 62 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV} 63 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999 64 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47" 65"
48case "${PV}" in
49 4.?.?_rc* | 4.?.?_beta* )
50 SRCTYPE="${SRCTYPE:-opensource-src}"
51 MY_PV="${PV/_/-}"
52 ;;
53 *)
54 SRCTYPE="${SRCTYPE:-opensource-src}"
55 MY_PV="${PV}"
56 ;;
57esac
58 66
59if version_is_at_least 4.5.99999999 ${PV} ; then
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}"
61else
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}"
63fi
64S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
65 68
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81
82# @FUNCTION: qt4-build_pkg_setup 69# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 70# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 71# Sets up PATH and LD_LIBRARY_PATH.
85qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
87 if [[ $EAPI != 2 ]]; then 74
88 # Make sure debug setting corresponds with qt-core (bug 258512) 75 # Protect users by not allowing downgrades between releases
89 if [[ $PN != "qt-core" ]]; then 76 # Downgrading revisions within the same release should be allowed
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 77 if has_version '>'${CATEGORY}/${P}-r9999; then
91 ~x11-libs/qt-core-${PV} debug" 78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:"
80 eerror " Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system"
82 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
92 fi 84 fi
85 fi
93 86
94 # Check USE requirements 87 if [[ ${PN} == "qt-webkit" ]]; then
95 qt4-build_check_use 88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi 96 fi
97 eshopts_pop
98 fi
97 99
98 PATH="${S}/bin:${PATH}" 100 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
103 else
104 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
105 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
106 # platform detection. Note: needs to come before any directories to
107 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}"
111 fi
100 112
113 # Make sure ebuilds use the required EAPI
114 if [[ ${EAPI} != [23] ]]; then
115 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
118 die "qt4-build eclass requires EAPI=2 or EAPI=3"
119 fi
120
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 121 if ! version_is_at_least 4.1 $(gcc-version); then
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 122 ewarn "Using a GCC version lower than 4.1 is not supported!"
103 echo
104 ebeep 3
105 fi 123 fi
106} 124}
107 125
108# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
109# @DESCRIPTION: 127# @DESCRIPTION:
110# Arguments for build_target_directories. Takes the directories, in which the 128# Arguments for build_target_directories. Takes the directories in which the
111# code should be compiled. This is a space-separated list 129# code should be compiled. This is a space-separated list.
112 130
113# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
114# @DESCRIPTION: 132# @DESCRIPTION:
115# Space separated list including the directories that will be extracted from Qt 133# Space-separated list including the directories that will be extracted from
116# tarball 134# Qt tarball.
117 135
118# @FUNCTION: qt4-build_src_unpack 136# @FUNCTION: qt4-build_src_unpack
119# @DESCRIPTION: 137# @DESCRIPTION:
120# Unpacks the sources 138# Unpacks the sources.
121qt4-build_src_unpack() { 139qt4-build_src_unpack() {
122 setqtenv 140 setqtenv
123 local target targets licenses tar_pkg tar_args 141
124 if version_is_at_least 4.5 ${PV} ; then 142 local tarball="${MY_P}.tar.gz" target= targets=
125 licenses="LICENSE.GPL3 LICENSE.LGPL" 143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
126 else
127 licenses="LICENSE.GPL2 LICENSE.GPL3"
128 fi
129 for target in configure ${licenses} projects.pro \
130 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 144 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
131 ${QT4_EXTRACT_DIRECTORIES}; do 145 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146 do
132 targets="${targets} ${MY_P}/${target}" 147 targets+="${MY_P}/${target} "
133 done 148 done
134 149
135 tar_pkg=${MY_P}.tar.bz2 150 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
136 tar_args="xjpf" 151 tar -xzf "${DISTDIR}/${tarball}" ${targets}
137 if version_is_at_least 4.5.3 ${PV} ; then 152 eend $? || die "failed to unpack"
138 tar_pkg=${tar_pkg/bz2/gz}
139 tar_args="xzpf"
140 fi
141
142 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
143 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
144
145 case "${PV}" in
146 4.4.?)
147 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
148 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
149 ;;
150 esac
151
152 # Be backwards compatible for now
153 if [[ $EAPI != 2 ]]; then
154 qt4-build_src_prepare
155 fi
156} 153}
157 154
158# @ECLASS-VARIABLE: PATCHES 155# @ECLASS-VARIABLE: PATCHES
156# @DEFAULT_UNSET
159# @DESCRIPTION: 157# @DESCRIPTION:
160# In case you have patches to apply, specify them in PATCHES variable. Make sure 158# PATCHES array variable containing all various patches to be applied.
161# to specify the full path. This variable is necessary for src_prepare phase. 159# This variable is expected to be defined in global scope of ebuild.
162# example: 160# Make sure to specify the full path. This variable is utilised in
163# PATCHES="${FILESDIR}"/mypatch.patch 161# src_unpack/src_prepare phase, based on EAPI.
164# ${FILESDIR}"/mypatch2.patch"
165# 162#
163# @CODE
164# PATCHES=( "${FILESDIR}/mypatch.patch"
165# "${FILESDIR}/patches_folder/" )
166# @CODE
166 167
167# @FUNCTION: qt4-build_src_prepare 168# @FUNCTION: qt4-build_src_prepare
168# @DESCRIPTION: 169# @DESCRIPTION:
169# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 170# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
170# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 171# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
171qt4-build_src_prepare() { 172qt4-build_src_prepare() {
172 setqtenv 173 setqtenv
173 cd "${S}" 174 cd "${S}"
174 175
176 if version_is_at_least "4.7"; then
177 # fix libX11 dependency on non X packages
178 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
179 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180
181 qt_assistant_cleanup
182 fi
183
184 if use aqua; then
185 # provide a proper macx-g++-64
186 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
187
188 sed -e '/^CONFIG/s:app_bundle::' \
189 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
190 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
191 fi
192
175 if [[ ${PN} != qt-core ]]; then 193 if [[ ${PN} != qt-core ]]; then
176 skip_qmake_build_patch 194 skip_qmake_build
177 skip_project_generation_patch 195 skip_project_generation
178 symlink_binaries_to_buildtree 196 symlink_binaries_to_buildtree
179 fi 197 fi
180 198
181 # Bug 282984 199 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
182 sed -e "s/\(^SYSTEM_VARIABLES\)/CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1/" \ 200 # qmake bus errors with -O2 but -O3 works
183 -i configure || die "sed qmake compilers failed" 201 replace-flags -O2 -O3
184 sed -e "s/\(\$MAKE\)/\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX)/" \ 202 fi
185 -i config.tests/unix/compile.test || die "sed test compilers failed"
186 203
187 # Bug 178652 204 # Bug 178652
188 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 205 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
189 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
190 append-flags -fno-gcse 207 append-flags -fno-gcse
191 fi 208 fi
192 209
210 if use_if_iuse c++0x; then
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 append-flags -std=c++0x
217 fi
218
193 # Unsupported old gcc versions - hardened needs this :( 219 # Unsupported old gcc versions - hardened needs this :(
194 if [[ $(gcc-major-version) -lt "4" ]] ; then 220 if [[ $(gcc-major-version) -lt 4 ]] ; then
195 ewarn "Appending -fno-stack-protector to CXXFLAGS" 221 ewarn "Appending -fno-stack-protector to CXXFLAGS"
196 append-cxxflags -fno-stack-protector 222 append-cxxflags -fno-stack-protector
197 # Bug 253127 223 # Bug 253127
198 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
199 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 225 -i mkspecs/common/g++.conf || die
200 fi 226 fi
201 227
202 # Bug 261632 228 # Bug 261632
203 if use ppc64; then 229 if use ppc64; then
204 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
205 append-flags -mminimal-toc 231 append-flags -mminimal-toc
206 fi 232 fi
207 233
234 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "/^SYSTEM_VARIABLES=/i \
236 CC='$(tc-getCC)'\n\
237 CXX='$(tc-getCXX)'\n\
238 CFLAGS='${CFLAGS}'\n\
239 CXXFLAGS='${CXXFLAGS}'\n\
240 LDFLAGS='${LDFLAGS}'\n" \
241 -i configure \
242 || die "sed SYSTEM_VARIABLES failed"
243
244 # Respect CC, CXX, LINK and *FLAGS in config.tests
245 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
246 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
247 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
248 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
249 || die "sed config.tests failed"
250
251 # Strip predefined CFLAGS from mkspecs (bug 312689)
252 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
253
208 # Bug 172219 254 # Bug 172219
255 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
256
257 if [[ ${CHOST} == *-darwin* ]]; then
258 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
259 # crippled (by design) :/
260 sed \
209 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 261 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
210 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 262 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
211 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 263 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
212 -e "s:X11R6/::" \ 264 -e "s:-arch\s\w*::g" \
213 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 265 -i mkspecs/common/mac-g++.conf \
266 || die "sed mkspecs/common/mac-g++.conf failed"
214 267
215 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 268 # Fix configure's -arch settings that appear in qmake/Makefile and also
216 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 269 # fix arch handling (automagically duplicates our -arch arg and breaks
217 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 270 # pch). Additionally disable Xarch support.
218 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 271 sed \
272 -e "s:-arch i386::" \
273 -e "s:-arch ppc::" \
274 -e "s:-arch x86_64::" \
275 -e "s:-arch ppc64::" \
276 -e "s:-arch \$i::" \
277 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
278 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
279 -e "s:-Xarch_x86_64::g" \
280 -e "s:-Xarch_ppc64::g" \
281 -i configure mkspecs/common/mac-g++.conf \
282 || die "sed -arch/-Xarch failed"
283
284 # On Snow Leopard don't fall back to 10.5 deployment target.
285 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
286 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
287 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
288 -i configure mkspecs/common/mac-g++.conf \
289 || die "sed deployment target failed"
290 fi
291 fi
292
293 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
296 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -i config.tests/unix/iconv/iconv.pro \
298 || die "sed iconv.pro failed"
299 fi
300
301 # we need some patches for Solaris
302 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
303 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
304 # use GCC over SunStudio
305 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
306 # do not flirt with non-Prefix stuff, we're quite possessive
307 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
308 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
219 309
220 base_src_prepare 310 base_src_prepare
221} 311}
222 312
223# @FUNCTION: qt4-build_src_configure 313# @FUNCTION: qt4-build_src_configure
225# Default configure phase 315# Default configure phase
226qt4-build_src_configure() { 316qt4-build_src_configure() {
227 setqtenv 317 setqtenv
228 myconf="$(standard_configure_options) ${myconf}" 318 myconf="$(standard_configure_options) ${myconf}"
229 319
320 # this one is needed for all systems with a separate -liconv, apart from
321 # Darwin, for which the sources already cater for -liconv
322 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
323 myconf+=" -liconv"
324
325 if use_if_iuse glib; then
326 # use -I, -L and -l from configure
327 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
328 # avoid the -pthread argument
329 myconf+=" ${glibflags//-pthread}"
330 unset glibflags
331 fi
332
333 if use_if_iuse qpa; then
334 ewarn
335 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
336 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
337 ewarn "disable it before reporting any bugs related to this useflag."
338 ewarn
339 myconf+=" -qpa"
340 fi
341
342 if use aqua ; then
343 # On (snow) leopard use the new (frameworked) cocoa code.
344 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
345 myconf+=" -cocoa -framework"
346
347 # We are crazy and build cocoa + qt3support :-)
348 if use qt3support; then
349 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
350 -i configure || die
351 fi
352
353 # We need the source's headers, not the installed ones.
354 myconf+=" -I${S}/include"
355
356 # Add hint for the framework location.
357 myconf+=" -F${QTLIBDIR}"
358 fi
359 else
360 # freetype2 include dir is non-standard, thus include it on configure
361 # use -I from configure
362 myconf+=" $(pkg-config --cflags freetype2)"
363 fi
364
230 echo ./configure ${myconf} 365 echo ./configure ${myconf}
231 ./configure ${myconf} || die "./configure failed" 366 ./configure ${myconf} || die "./configure failed"
232 myconf="" 367 myconf=""
368
369 prepare_directories ${QT4_TARGET_DIRECTORIES}
233} 370}
234 371
235# @FUNCTION: qt4-build_src_compile 372# @FUNCTION: qt4-build_src_compile
373# @DESCRIPTION:
236# @DESCRIPTION: Actual compile phase 374# Actual compile phase
237qt4-build_src_compile() { 375qt4-build_src_compile() {
238 setqtenv 376 setqtenv
239 # Be backwards compatible for now
240 if [[ $EAPI != 2 ]]; then
241 qt4-build_src_configure
242 fi
243 377
244 build_directories "${QT4_TARGET_DIRECTORIES}" 378 build_directories ${QT4_TARGET_DIRECTORIES}
379}
380
381# @FUNCTION: qt4-build_src_test
382# @DESCRIPTION:
383# Runs tests only in target directories.
384qt4-build_src_test() {
385 for dir in ${QT4_TARGET_DIRECTORIES}; do
386 emake -j1 check -C ${dir}
387 done
388}
389
390# @FUNCTION: fix_includes
391# @DESCRIPTION:
392# For MacOS X we need to add some symlinks when frameworks are
393# being used, to avoid complications with some more or less stupid packages.
394fix_includes() {
395 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
396 # Some packages tend to include <Qt/...>
397 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
398
399 # Fake normal headers when frameworks are installed... eases life later on
400 local dest f h
401 for frw in "${D}${QTLIBDIR}"/*.framework; do
402 [[ -e "${frw}"/Headers ]] || continue
403 f=$(basename ${frw})
404 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
405 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
406
407 # Link normal headers as well.
408 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
409 h=$(basename ${hdr})
410 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
411 done
412 done
413 fi
245} 414}
246 415
247# @FUNCTION: qt4-build_src_install 416# @FUNCTION: qt4-build_src_install
248# @DESCRIPTION: 417# @DESCRIPTION:
249# Perform the actual installation including some library fixes. 418# Perform the actual installation including some library fixes.
250qt4-build_src_install() { 419qt4-build_src_install() {
420 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
251 setqtenv 421 setqtenv
422
252 install_directories "${QT4_TARGET_DIRECTORIES}" 423 install_directories ${QT4_TARGET_DIRECTORIES}
253 install_qconfigs 424 install_qconfigs
254 fix_library_files 425 fix_library_files
426 fix_includes
427
428 # remove .la files since we are building only shared Qt libraries
429 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
255} 430}
256 431
257# @FUNCTION: setqtenv 432# @FUNCTION: setqtenv
433# @INTERNAL
258setqtenv() { 434setqtenv() {
259 # Set up installation directories 435 # Set up installation directories
260 QTBASEDIR=/usr/$(get_libdir)/qt4
261 QTPREFIXDIR=/usr 436 QTPREFIXDIR=${EPREFIX}/usr
262 QTBINDIR=/usr/bin 437 QTBINDIR=${EPREFIX}/usr/bin
263 QTLIBDIR=/usr/$(get_libdir)/qt4 438 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
264 QMAKE_LIBDIR_QT=${QTLIBDIR}
265 QTPCDIR=/usr/$(get_libdir)/pkgconfig 439 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
266 QTDATADIR=/usr/share/qt4
267 QTDOCDIR=/usr/share/doc/qt-${PV} 440 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
268 QTHEADERDIR=/usr/include/qt4 441 QTHEADERDIR=${EPREFIX}/usr/include/qt4
269 QTPLUGINDIR=${QTLIBDIR}/plugins 442 QTPLUGINDIR=${QTLIBDIR}/plugins
270 QTSYSCONFDIR=/etc/qt4 443 QTIMPORTDIR=${QTLIBDIR}/imports
444 QTDATADIR=${EPREFIX}/usr/share/qt4
271 QTTRANSDIR=${QTDATADIR}/translations 445 QTTRANSDIR=${QTDATADIR}/translations
446 QTSYSCONFDIR=${EPREFIX}/etc/qt4
272 QTEXAMPLESDIR=${QTDATADIR}/examples 447 QTEXAMPLESDIR=${QTDATADIR}/examples
273 QTDEMOSDIR=${QTDATADIR}/demos 448 QTDEMOSDIR=${QTDATADIR}/demos
449 QMAKE_LIBDIR_QT=${QTLIBDIR}
274 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4 450 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
451
275 PLATFORM=$(qt_mkspecs_dir) 452 PLATFORM=$(qt_mkspecs_dir)
276 453
277 unset QMAKESPEC 454 unset QMAKESPEC
278} 455}
279 456
280# @FUNCTION: standard_configure_options 457# @FUNCTION: standard_configure_options
458# @INTERNAL
281# @DESCRIPTION: 459# @DESCRIPTION:
282# Sets up some standard configure options, like libdir (if necessary), whether 460# Sets up some standard configure options, like libdir (if necessary), whether
283# debug info is wanted or not. 461# debug info is wanted or not.
284standard_configure_options() { 462standard_configure_options() {
285 local myconf="" 463 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
464 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
465 -importdir ${QTIMPORTDIR} -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR}
466 -sysconfdir ${QTSYSCONFDIR} -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
467 -opensource -confirm-license -shared -fast -largefile -stl -verbose
468 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
286 469
287 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 470 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
288 471
289 # Disable visibility explicitly if gcc version isn't 4 472 # debug/release
290 if [[ "$(gcc-major-version)" -lt "4" ]]; then
291 myconf="${myconf} -no-reduce-exports"
292 fi
293
294 # precompiled headers doesn't work on hardened, where the flag is masked.
295 if use pch; then 473 if use debug; then
296 myconf="${myconf} -pch" 474 myconf+=" -debug"
297 else 475 else
298 myconf="${myconf} -no-pch" 476 myconf+=" -release"
299 fi 477 fi
300
301 if use debug; then
302 myconf="${myconf} -debug -no-separate-debug-info" 478 myconf+=" -no-separate-debug-info"
303 else 479
304 myconf="${myconf} -release -no-separate-debug-info" 480 # exceptions USE flag
305 fi 481 local exceptions="-exceptions"
482 in_iuse exceptions && exceptions="$(qt_use exceptions)"
483 myconf+=" ${exceptions}"
484
485 # disable RPATH on Qt >= 4.8 (bug 380415)
486 version_is_at_least 4.8 && myconf+=" -no-rpath"
487
488 # precompiled headers don't work on hardened, where the flag is masked
489 myconf+=" $(qt_use pch)"
490
491 # -reduce-relocations
492 # This flag seems to introduce major breakage to applications,
493 # mostly to be seen as a core dump with the message "QPixmap: Must
494 # construct a QApplication before a QPaintDevice" on Solaris.
495 # -- Daniel Vergien
496 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
497
498 use aqua && myconf+=" -no-framework"
306 499
307 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 500 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
308 # $(tc-arch). Therefore we convert it to supported values. 501 # $(tc-arch). Therefore we convert it to supported values.
309 case "$(tc-arch)" in 502 case "$(tc-arch)" in
310 amd64) myconf="${myconf} -arch x86_64" ;; 503 amd64|x64-*) myconf+=" -arch x86_64" ;;
504 ppc-macos) myconf+=" -arch ppc" ;;
311 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 505 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
506 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
507 x86-macos) myconf+=" -arch x86" ;;
312 x86|x86-*) myconf="${myconf} -arch i386" ;; 508 x86|x86-*) myconf+=" -arch i386" ;;
313 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 509 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
314 hppa|sh) myconf="${myconf} -arch generic" ;; 510 hppa|sh) myconf+=" -arch generic" ;;
315 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 511 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
316 esac 512 esac
317 513
318 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build
319 local exceptions=
320 case "${PV}" in
321 4.6.*)
322 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then
323 exceptions="-no-exceptions"
324 fi
325 ;;
326 *)
327 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
328 ;;
329 esac
330
331 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
332 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
333 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
334 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
335 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
336 -demosdir ${QTDEMOSDIR} -silent -fast
337 ${exceptions}
338 -reduce-relocations -nomake examples -nomake demos"
339
340 # Make eclass >= 4.5.x ready
341 case "${MY_PV}" in
342 4.5.* | 4.6.* )
343 myconf="${myconf} -opensource"
344 ;;
345 esac
346
347 echo "${myconf}" 514 echo "${myconf}"
348} 515}
516
517# @FUNCTION: prepare_directories
518# @USAGE: < directories >
519# @INTERNAL
520# @DESCRIPTION:
521# Generates Makefiles for the given list of directories.
522prepare_directories() {
523 for x in "$@"; do
524 pushd "${S}"/${x} >/dev/null || die
525 einfo "Running qmake in: ${x}"
526 # avoid running over the maximum argument number, bug #299810
527 {
528 echo "${S}"/mkspecs/common/*.conf
529 find "${S}" -name '*.pr[io]'
530 } | xargs sed -i \
531 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
532 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
533 || die
534 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
535 popd >/dev/null || die
536 done
537}
538
349 539
350# @FUNCTION: build_directories 540# @FUNCTION: build_directories
351# @USAGE: < directories > 541# @USAGE: < directories >
542# @INTERNAL
352# @DESCRIPTION: 543# @DESCRIPTION:
353# Compiles the code in $QT4_TARGET_DIRECTORIES 544# Compiles the code in the given list of directories.
354build_directories() { 545build_directories() {
355 local dirs="$@"
356 for x in ${dirs}; do 546 for x in "$@"; do
357 cd "${S}"/${x} 547 pushd "${S}"/${x} >/dev/null || die
358 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 548 emake CC="$(tc-getCC)" \
359 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 549 CXX="$(tc-getCXX)" \
360 emake CC="@echo compiling \$< && $(tc-getCC)" \
361 CXX="@echo compiling \$< && $(tc-getCXX)" \
362 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 550 LINK="$(tc-getCXX)" || die "emake failed"
551 popd >/dev/null || die
363 done 552 done
364} 553}
365 554
366# @FUNCTION: install_directories 555# @FUNCTION: install_directories
367# @USAGE: < directories > 556# @USAGE: < directories >
557# @INTERNAL
368# @DESCRIPTION: 558# @DESCRIPTION:
369# run emake install in the given directories, which are separated by spaces 559# Runs emake install in the given directories, which are separated by spaces.
370install_directories() { 560install_directories() {
371 local dirs="$@"
372 for x in ${dirs}; do 561 for x in "$@"; do
373 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 562 pushd "${S}"/${x} >/dev/null || die
374 emake INSTALL_ROOT="${D}" install || die "emake install failed" 563 emake INSTALL_ROOT="${D}" install || die "emake install failed"
375 popd >/dev/null || die "Can't popd from ${S}/${x}" 564 popd >/dev/null || die
376 done 565 done
377} 566}
378 567
379# @ECLASS-VARIABLE: QCONFIG_ADD 568# @ECLASS-VARIABLE: QCONFIG_ADD
380# @DESCRIPTION: 569# @DESCRIPTION:
381# List options that need to be added to QT_CONFIG in qconfig.pri 570# List options that need to be added to QT_CONFIG in qconfig.pri
382QCONFIG_ADD="${QCONFIG_ADD:-}" 571: ${QCONFIG_ADD:=}
383 572
384# @ECLASS-VARIABLE: QCONFIG_REMOVE 573# @ECLASS-VARIABLE: QCONFIG_REMOVE
385# @DESCRIPTION: 574# @DESCRIPTION:
386# List options that need to be removed from QT_CONFIG in qconfig.pri 575# List options that need to be removed from QT_CONFIG in qconfig.pri
387QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 576: ${QCONFIG_REMOVE:=}
388 577
389# @ECLASS-VARIABLE: QCONFIG_DEFINE 578# @ECLASS-VARIABLE: QCONFIG_DEFINE
390# @DESCRIPTION: 579# @DESCRIPTION:
391# List variables that should be defined at the top of QtCore/qconfig.h 580# List variables that should be defined at the top of QtCore/qconfig.h
392QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 581: ${QCONFIG_DEFINE:=}
393 582
394# @FUNCTION: install_qconfigs 583# @FUNCTION: install_qconfigs
584# @INTERNAL
585# @DESCRIPTION:
395# @DESCRIPTION: Install gentoo-specific mkspecs configurations 586# Install gentoo-specific mkspecs configurations.
396install_qconfigs() { 587install_qconfigs() {
397 local x 588 local x
398 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 589 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
399 for x in QCONFIG_ADD QCONFIG_REMOVE; do 590 for x in QCONFIG_ADD QCONFIG_REMOVE; do
400 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 591 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
401 done 592 done
402 insinto ${QTDATADIR}/mkspecs/gentoo 593 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
403 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 594 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
404 fi 595 fi
405 596
406 if [[ -n ${QCONFIG_DEFINE} ]]; then 597 if [[ -n ${QCONFIG_DEFINE} ]]; then
407 for x in ${QCONFIG_DEFINE}; do 598 for x in ${QCONFIG_DEFINE}; do
408 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 599 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
409 done 600 done
410 insinto ${QTHEADERDIR}/Gentoo 601 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
411 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 602 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
412 fi 603 fi
413} 604}
414 605
415# @FUNCTION: generate_qconfigs 606# @FUNCTION: generate_qconfigs
416# @DESCRIPTION: Generates gentoo-specific configurations 607# @INTERNAL
608# @DESCRIPTION:
609# Generates gentoo-specific qconfig.{h,pri}.
417generate_qconfigs() { 610generate_qconfigs() {
418 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 611 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
419 local x qconfig_add qconfig_remove qconfig_new 612 local x qconfig_add qconfig_remove qconfig_new
420 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 613 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
421 [[ -f ${x} ]] || continue 614 [[ -f ${x} ]] || continue
422 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 615 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
423 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 616 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
424 done 617 done
425 618
426 # these error checks do not use die because dying in pkg_post{inst,rm} 619 # these error checks do not use die because dying in pkg_post{inst,rm}
427 # just makes things worse. 620 # just makes things worse.
428 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 621 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
435 628
436 # generate list of QT_CONFIG entries from the existing list 629 # generate list of QT_CONFIG entries from the existing list
437 # including qconfig_add and excluding qconfig_remove 630 # including qconfig_add and excluding qconfig_remove
438 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 631 for x in $(sed -n 's/^QT_CONFIG +=//p' \
439 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 632 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
440 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 633 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
441 done 634 done
442 635
443 # replace the existing QT_CONFIG list with qconfig_new 636 # replace the existing QT_CONFIG list with qconfig_new
444 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 637 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
445 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 638 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
469 fi 662 fi
470 fi 663 fi
471} 664}
472 665
473# @FUNCTION: qt4-build_pkg_postrm 666# @FUNCTION: qt4-build_pkg_postrm
667# @DESCRIPTION:
474# @DESCRIPTION: Generate configurations when the package is completely removed 668# Regenerate configuration when the package is completely removed.
475qt4-build_pkg_postrm() { 669qt4-build_pkg_postrm() {
476 generate_qconfigs 670 generate_qconfigs
477} 671}
478 672
479# @FUNCTION: qt4-build_pkg_postinst 673# @FUNCTION: qt4-build_pkg_postinst
674# @DESCRIPTION:
480# @DESCRIPTION: Generate configuration, plus throws a message about possible 675# Regenerate configuration, plus throw a message about possible
481# breakages and proposed solutions. 676# breakages and proposed solutions.
482qt4-build_pkg_postinst() { 677qt4-build_pkg_postinst() {
483 generate_qconfigs 678 generate_qconfigs
484 echo
485 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
486 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
487 ewarn "should recompile the packages providing these plugins. Also, make sure you"
488 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
489 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
490 ewarn
491 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
492 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
493 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
494 ewarn "configuration."
495 ewarn
496 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
497 echo
498} 679}
499 680
500# @FUNCTION: skip_qmake_build_patch 681# @FUNCTION: skip_qmake_build
682# @INTERNAL
501# @DESCRIPTION: 683# @DESCRIPTION:
502# Don't need to build qmake, as it's already installed from qt-core 684# Patches configure to skip qmake compilation, as it's already installed by qt-core.
503skip_qmake_build_patch() { 685skip_qmake_build() {
504 # Don't need to build qmake, as it's already installed from qt-core
505 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 686 sed -i -e "s:if true:if false:g" "${S}"/configure || die
506} 687}
507 688
508# @FUNCTION: skip_project_generation_patch 689# @FUNCTION: skip_project_generation
690# @INTERNAL
509# @DESCRIPTION: 691# @DESCRIPTION:
510# Exit the script early by throwing in an exit before all of the .pro files are scanned 692# Exit the script early by throwing in an exit before all of the .pro files are scanned.
511skip_project_generation_patch() { 693skip_project_generation() {
512 # Exit the script early by throwing in an exit before all of the .pro files are scanned
513 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 694 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
514 -i "${S}"/configure || die "Sed failed"
515} 695}
516 696
517# @FUNCTION: symlink_binaries_to_buildtree 697# @FUNCTION: symlink_binaries_to_buildtree
698# @INTERNAL
518# @DESCRIPTION: 699# @DESCRIPTION:
519# Symlink generated binaries to buildtree so they can be used during compilation 700# Symlinks generated binaries to buildtree, so they can be used during compilation time.
520# time
521symlink_binaries_to_buildtree() { 701symlink_binaries_to_buildtree() {
522 for bin in qmake moc uic rcc; do 702 for bin in qmake moc uic rcc; do
523 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 703 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
524 done 704 done
525} 705}
526 706
527# @FUNCTION: fix_library_files 707# @FUNCTION: fix_library_files
708# @INTERNAL
528# @DESCRIPTION: 709# @DESCRIPTION:
529# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 710# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
530# moves the *.pc-files into the pkgconfig directory 711# moves the *.pc files into the pkgconfig directory.
531fix_library_files() { 712fix_library_files() {
713 local libfile
532 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 714 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
533 if [[ -e ${libfile} ]]; then 715 if [[ -e ${libfile} ]]; then
534 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 716 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
535 fi 717 fi
536 done 718 done
537 719
538 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 720 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
539 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 721 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
540 if [[ -e ${libfile} ]]; then 722 if [[ -e ${libfile} ]]; then
541 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 723 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
542 724
543 # Move .pc files into the pkgconfig directory 725 # Move .pc files into the pkgconfig directory
544 dodir ${QTPCDIR} 726 dodir ${QTPCDIR#${EPREFIX}}
545 mv ${libfile} "${D}"/${QTPCDIR}/ \ 727 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
546 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
547 fi 728 fi
548 done 729 done
549 730
550 # Don't install an empty directory 731 # Don't install an empty directory
551 rmdir "${D}"/${QTLIBDIR}/pkgconfig 732 rmdir "${D}"/${QTLIBDIR}/pkgconfig
552} 733}
553 734
554# @FUNCTION: qt_use 735# @FUNCTION: qt_use
555# @USAGE: < flag > [ feature ] [ enableval ] 736# @USAGE: < flag > [ feature ] [ enableval ]
556# @DESCRIPTION: 737# @DESCRIPTION:
557# This will echo "${enableval}-${feature}" if <flag> is enabled, or 738# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
558# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 739# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
559# will be used for that. If [enableval] is not specified, it omits the 740# will be used for that. If [enableval] is not specified, it omits the
560# assignment-part 741# "-${enableval}" part.
561qt_use() { 742qt_use() {
562 local flag="${1}" 743 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
563 local feature="${1}"
564 local enableval=
565
566 [[ -n ${2} ]] && feature=${2}
567 [[ -n ${3} ]] && enableval="-${3}"
568
569 if use ${flag}; then
570 echo "${enableval}-${feature}"
571 else
572 echo "-no-${feature}"
573 fi
574}
575
576# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
577# @DESCRIPTION:
578# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
579# (eutils.eclass), line per line.
580#
581# Example:
582# @CODE
583# pkg_setup() {
584# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
585# ~x11-libs/qt-gui-${PV} qt3support"
586# qt4-build_check_use
587# }
588# @CODE
589
590# Run built_with_use on each flag and print appropriate error messages if any
591# flags are missing
592
593_qt_built_with_use() {
594 local missing opt pkg flag flags
595
596 if [[ ${1} = "--missing" ]]; then
597 missing="${1} ${2}" && shift 2
598 fi
599 if [[ ${1:0:1} = "-" ]]; then
600 opt=${1} && shift
601 fi
602
603 pkg=${1} && shift
604
605 for flag in "${@}"; do
606 flags="${flags} ${flag}"
607 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
608 flags="${flags}*"
609 else
610 [[ ${opt} = "-o" ]] && return 0
611 fi
612 done
613 if [[ "${flags# }" = "${@}" ]]; then
614 return 0
615 fi
616 if [[ ${opt} = "-o" ]]; then
617 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
618 else
619 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
620 fi
621 return 1
622}
623
624# @FUNCTION: qt4-build_check_use
625# @DESCRIPTION:
626# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
627# USE flags listed.
628#
629# If any of the required USE flags are missing, an eerror will be printed for
630# each package with missing USE flags.
631qt4-build_check_use() {
632 local line missing
633 while read line; do
634 [[ -z ${line} ]] && continue
635 if ! _qt_built_with_use ${line}; then
636 missing=true
637 fi
638 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
639 if [[ -n ${missing} ]]; then
640 echo
641 eerror "Flags marked with an * are missing."
642 die "Missing USE flags found"
643 fi
644} 744}
645 745
646# @FUNCTION: qt_mkspecs_dir 746# @FUNCTION: qt_mkspecs_dir
647# @RETURN: the specs-directory w/o path 747# @RETURN: the specs-directory w/o path
648# @DESCRIPTION: 748# @DESCRIPTION:
649# Allows us to define which mkspecs dir we want to use. 749# Allows us to define which mkspecs dir we want to use.
650qt_mkspecs_dir() { 750qt_mkspecs_dir() {
651 # Allows us to define which mkspecs dir we want to use.
652 local spec 751 local spec=
653
654 case ${CHOST} in 752 case ${CHOST} in
655 *-freebsd*|*-dragonfly*) 753 *-freebsd*|*-dragonfly*)
656 spec="freebsd" ;; 754 spec=freebsd ;;
657 *-openbsd*) 755 *-openbsd*)
658 spec="openbsd" ;; 756 spec=openbsd ;;
659 *-netbsd*) 757 *-netbsd*)
660 spec="netbsd" ;; 758 spec=netbsd ;;
661 *-darwin*) 759 *-darwin*)
760 if use aqua; then
761 # mac with carbon/cocoa
762 spec=macx
763 else
764 # darwin/mac with x11
662 spec="darwin" ;; 765 spec=darwin
766 fi
767 ;;
768 *-solaris*)
769 spec=solaris ;;
663 *-linux-*|*-linux) 770 *-linux-*|*-linux)
664 spec="linux" ;; 771 spec=linux ;;
665 *) 772 *)
666 die "Unknown CHOST, no platform choosen." 773 die "Unknown CHOST, no platform chosen"
667 esac 774 esac
668 775
669 CXX=$(tc-getCXX) 776 CXX=$(tc-getCXX)
670 if [[ ${CXX/g++/} != ${CXX} ]]; then 777 if [[ ${CXX} == *g++* ]]; then
671 spec="${spec}-g++" 778 spec+=-g++
672 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 779 elif [[ ${CXX} == *icpc* ]]; then
673 spec="${spec}-icc" 780 spec+=-icc
674 else 781 else
675 die "Unknown compiler ${CXX}." 782 die "Unknown compiler '${CXX}'"
676 fi 783 fi
677 if [[ -n "${LIBDIR/lib}" ]]; then 784 if [[ -n ${LIBDIR/lib} ]]; then
678 spec="${spec}-${LIBDIR/lib}" 785 spec+=-${LIBDIR/lib}
786 fi
787
788 # Add -64 for 64bit profiles
789 if use x64-freebsd ||
790 use amd64-linux ||
791 use x64-macos ||
792 use x64-solaris ||
793 use sparc64-solaris
794 then
795 spec+=-64
679 fi 796 fi
680 797
681 echo "${spec}" 798 echo "${spec}"
682} 799}
683 800
684case ${EAPI:-0} in 801# @FUNCTION: qt_assistant_cleanup
685 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 802# @INTERNAL
803# @DESCRIPTION:
804# Tries to clean up tools.pro for qt-assistant ebuilds.
805# Meant to be called in src_prepare().
806# Since Qt 4.7.4 this function is a no-op.
807qt_assistant_cleanup() {
808 # apply patching to qt-assistant ebuilds only
809 [[ ${PN} != "qt-assistant" ]] && return
810
811 # no longer needed for 4.7.4 and later
812 version_is_at_least "4.7.4" && return
813
814 # different versions (and branches...) may need different handling,
815 # add a case if you need special handling
816 case "${MY_PV_EXTRA}" in
817 *kde-qt*)
818 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
819 -e "/mac/,/^embedded.*makeqpf$/d" \
820 -i tools/tools.pro || die "patching tools.pro failed"
821 ;;
822 *)
823 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
824 -e "/mac/,/^embedded.*makeqpf$/d" \
825 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
826 -i tools/tools.pro || die "patching tools.pro failed"
827 ;;
828 esac
829}
830
831# @FUNCTION: qt_nolibx11
832# @INTERNAL
833# @DESCRIPTION:
834# Ignore X11 tests for packages that don't need X libraries installed.
835qt_nolibx11() {
836 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
837 die "x11 check sed failed"
838}
839
686 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 840EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
687esac

Legend:
Removed from v.1.51  
changed lines
  Added in v.1.114

  ViewVC Help
Powered by ViewVC 1.1.20